/* jdwang@asia.edu.tw 2017.2.23
 * For Windoop Environment 
 * HADOOP_HOME ${eclipse_home}\..\hadoop
 * PATH %PATH%;${eclipse_home}\..\hadoop\bin
 */ 
package jdwang.hadoop;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.Reducer;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;

public class TDCS_MRP_Main_TimeInterval_Statistic_AsiaCDH {
	public static void main(String[] args) throws Exception {
		
		Configuration conf = new Configuration();
		boolean useResourceManager = true; 
		if(useResourceManager)
		{
			/* Windoop
			conf.set("fs.defaultFS", "hdfs://0.0.0.0:9000");
			conf.set("mapreduce.framework.name", "yarn");
			//conf.set("yarn.nodemanager.aux-services","mapreduce_shuffle");
			//conf.set("yarn.resourcemanager.hostname", "0.0.0.0");
			//conf.set("yarn.nodemanager.hostname", "0.0.0.0");		
			conf.set("yarn.app.mapreduce.am.resource.mb","2560"); 

			//conf.set("yarn.app.mapreduce.am.command-opts","6625"); 	

			conf.set("mapreduce.map.memory.mb","1536");
			//Larger resource limit for reduces.
			conf.set("mapreduce.reduce.memory.mb","2560");
			//Larger heap-size for child jvms of map
			conf.set("mapreduce.map.java.opts","-Xmx1280m");
			//Larger heap-size for child jvms of reduces.
			conf.set("mapreduce.reduce.java.opts","-Xmx2304m");  
			*/
			
			// H204 
			/*
			conf.set("fs.default.name", "hdfs://H204HDP1:9000");
			conf.set("mapred.job.tracker", "H204HDP1:9001");
			conf.set("mapreduce.framework.name","yarn");
			conf.set("yarn.resourcemanager.address","H204HDP1:8032");
			conf.set("yarn.resourcemanager.scheduler.address","H204HDP1:8030");
			conf.set("yarn.web-proxy.address","H204HDP1:8088");
			
			conf.set("mapreduce.map.memory.mb","12288");
			//Larger resource limit for reduces.
			conf.set("mapreduce.reduce.memory.mb","12288");
			//Larger heap-size for child jvms of map
			conf.set("mapreduce.map.java.opts","-Xmx8196m");
			//Larger heap-size for child jvms of reduces.
			conf.set("mapreduce.reduce.java.opts","-Xmx8196m");
			// The total amount of buffer memory to use while sorting files, in megabytes. 
			conf.set("mapreduce.task.io.sort.mb","1024");
			*/
			// cdh01
	  		/*
			conf.set("fs.default.name", "hdfs://cdh01:8020");
			//conf.set("mapred.job.tracker", "cdh01:9001");
			conf.set("mapreduce.framework.name","yarn");
			conf.set("yarn.resourcemanager.address","cdh01:8032");
			conf.set("yarn.resourcemanager.scheduler.address","cdh01:8030");
			conf.set("yarn.web-proxy.address","cdh01:8088");
							
			conf.set("mapreduce.map.memory.mb","48000");
			//Larger resource limit for reduces.
			conf.set("mapreduce.reduce.memory.mb","48000");
			//Larger heap-size for child jvms of map
			conf.set("mapreduce.map.java.opts","-Xmx40000m");
			//Larger heap-size for child jvms of reduces.
			conf.set("mapreduce.reduce.java.opts","-Xmx40000m");
			// The total amount of buffer memory to use while sorting files, in megabytes. 
			conf.set("mapreduce.task.io.sort.mb","2047");
			*/
	  		
	  		//	 	master1.etu.asia
	  		/*
	  		conf.set("fs.default.name", "hdfs://master1.etu.asia:8020");
	  		//conf.set("mapred.job.tracker", "cdh01:9001");
	  		conf.set("mapreduce.framework.name","yarn");
	  		conf.set("yarn.resourcemanager.address","master1.etu.asia:8032");
	  		conf.set("yarn.resourcemanager.scheduler.address","master1.etu.asia:8030");
	  		conf.set("yarn.web-proxy.address","master1.etu.asia:8088");
	  		*/
	  		//	 	master2.etu.asia
	  		/*
	  		conf.set("fs.default.name", "hdfs://master2.etu.asia:8020");
	  		//conf.set("mapred.job.tracker", "cdh01:9001");
	  		conf.set("mapreduce.framework.name","yarn");
	  		conf.set("yarn.resourcemanager.address","master2.etu.asia:8032");
	  		conf.set("yarn.resourcemanager.scheduler.address","master2.etu.asia:8030");
	  		conf.set("yarn.web-proxy.address","master2.etu.asia:8088");
			*/
			conf.set("mapreduce.task.timeout","6000000");
			
	  		conf.set("mapreduce.map.memory.mb","70000");
	  		//Larger resource limit for reduces.
	  		conf.set("mapreduce.reduce.memory.mb","70000");
	  		//Larger heap-size for child jvms of map
	  		conf.set("mapreduce.map.java.opts","-Xmx65000m");
	  		//Larger heap-size for child jvms of reduces.
	  		conf.set("mapreduce.reduce.java.opts","-Xmx65000m");
	  		// The total amount of buffer memory to use while sorting files, in megabytes. 
	  		//conf.set("mapreduce.task.io.sort.mb","4095");
	  		conf.set("mapreduce.task.io.sort.mb","2047");
		}
		else
		{
			conf.set("fs.defaultFS", "file:///");
			conf.set("mapreduce.framework.name", "local");
			//conf.set("yarn.resourcemanager.address", "localhost");
			conf.set("hadoop.tmp.dir", "/windoop/tmp/hadoop-${user.name}");
		} 	 	
		
		Job job = Job.getInstance(conf, "TDCS_MRP_Main_TimeInterval_Statistic_AsiaCDH");
		job.setJarByClass(TDCS_MRP_Main_TimeInterval_Statistic_AsiaCDH.class);
		// TODO: specify a mapper
		//job.setMapperClass(Mapper.class); 
		//job.setMapperClass(TDCS_MRP_Mapper.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_1.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_2.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_3.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_4_Filter_StartEndGantyrID.class);
		//job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_4_Filter_WeekDay_StartEndGantyrID.class);
		job.setMapperClass(TDCS_MRP_TimeInterval_Mapper_4_Filter_VehicleType_WeekDay_StartEndGantyrID.class);
		
		// TODO: specify a reducer
		//job.setReducerClass(Reducer.class); 
		//job.setReducerClass(TDCS_MRP_Reducer.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_1.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_2.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_3.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_4_Filter_StartEndGantyrID.class);
		//job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_4_Filter_Weekday_StartEndGantyrID.class);
		job.setReducerClass(TDCS_MRP_TimeInterval_Reducer_4_Filter_VehicleType_Weekday_StartEndGantyrID.class);

		//job.setNumReduceTasks(10);   //reduce

		// TODO: specify output types
		///*
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(Text.class);
		//*/
		/*
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(IntWritable.class);
		*/ 
		// TODO: specify input and output DIRECTORIES (not files)
		//FileInputFormat.setInputPaths(job, new Path("TDCS_MRP_Temp"));
		//FileInputFormat.setInputPaths(job, new Path("TDCS_MRP"));
		//FileOutputFormat.setOutputPath(job, new Path("TDCS_MRP_Output"));
		
		/*
		String Input = "./TDCS/TDCS_CandidateMR_2016_11-12_2017_3_Date-Weekday-Vehicle_M1_TF2_CF1_Length1_MRP_SpecificGantryIDS";
		String Output = "./TDCS/TDCS_CandidateMR_2016_11-12_2017_3_Date-Weekday-Vehicle_M1_TF2_CF1_Length1_MRP_SpecificGantryIDS_Output";
		*/
		
		String Input = "./TDCS/TDCS_CandidateMR_2016_11-12_2017_3_Date-Weekday-Vehicle_M1_TF2_CF1_Length1_MRP";
		//String Output = "./TDCS/TDCS_CandidateMR_2016_11-12_2017_3_Date-Weekday-Vehicle_M1_TF2_CF1_Length1_MRP_No5_S_VehicleTypes_24Hours";
		String Output = "./TDCS/TDCS_CandidateMR_2016_11-12_2017_3_Date-Weekday-Vehicle_M1_TF2_CF1_Length1_MRP_No5_N_VehicleTypes_24Hours";
		
		FileInputFormat.setInputPaths(job, new Path(Input));
		
		FileSystem hdfs = FileSystem.get(conf);
		Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+Output);
		
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_Temp_Interval_Output");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_Interval_Output");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_QantryID_Hour_Interval_Output");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_QantryID_Hour_Interval_Statistics_Output");
		//Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+"TDCS_MRP_QantryID_Hour_Interval_Statistics_FilterStratEndGantry_Output");
				
		FileOutputFormat.setOutputPath(job, outputPath);
			
		if(hdfs.exists(outputPath)) {
	  		hdfs.delete(outputPath, true);
	  	}
		/*
		if (!job.waitForCompletion(true))
			return;
			*/
		if(job.waitForCompletion(true))
	  	{
	  		System.out.println("Job Done!");
	  		System.exit(0);
	  	}
	  	else
	  	{
	  		System.out.println("Job Failed!");
	  		System.exit(1);
	  	}    
	}

}
